"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const react_native_svg_uri_1 = __importDefault(require("../../lib/react-native-svg-uri"));
const svg_1 = __importDefault(require("../../assets/svg"));
const Navbar = props => {
    const { name, color = '#666', size = 20, onPress } = props;
    let svgXmlData = svg_1.default[name];
    if (!svgXmlData) {
        throw new Error(`No Icon Named ${name} Was Found!`);
    }
    return (<react_native_1.Pressable onPress={onPress}>
      <react_native_svg_uri_1.default width={size} height={size} svgXmlData={svgXmlData} fill={color}/>
    </react_native_1.Pressable>);
};
exports.default = Navbar;
