"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const TabBar = props => {
    const { height = 50, iconSize = 20, activeColor = '#5098FF', inactiveColor = '#606266', showBorderTop = true, backgroundColor = '#FFFFFF', children, } = props;
    const getPanes = (showContent) => {
        let selectedIndex = 0;
        [].concat(children).forEach((child, idx) => {
            if (child.props.selected) {
                selectedIndex = idx;
            }
        });
        const newChildren = [];
        react_1.Children.map(children, (child, idx) => {
            if (showContent && selectedIndex === idx) {
                newChildren.push(<react_native_1.View key={idx} style={{ flex: 1 }}>
            {child.props.children}
          </react_native_1.View>);
            }
            else {
                newChildren.push(react_1.cloneElement(child, {
                    key: idx,
                    activeColor,
                    inactiveColor,
                    iconSize,
                }));
            }
        });
        if (showContent) {
            return newChildren.filter((_, i) => i === selectedIndex);
        }
        return newChildren;
    };
    return (<react_native_1.SafeAreaView style={[styles.page, { paddingBottom: height }]}>
      {getPanes(true)}
      <react_native_1.View style={[styles.tabBar, { backgroundColor, height }, showBorderTop && styles.borderTop]}>
        {getPanes(false)}
      </react_native_1.View>
    </react_native_1.SafeAreaView>);
};
const styles = react_native_1.StyleSheet.create({
    page: {
        position: 'relative',
        flex: 1,
    },
    tabBar: {
        position: 'absolute',
        bottom: 0,
        left: 0,
        width: '100%',
        display: 'flex',
        flexDirection: 'row',
    },
    borderTop: {
        borderTopColor: '#E4E7ED',
        borderTopWidth: 1,
    },
});
exports.default = TabBar;
